#!/usr/bin/env python
# -*- coding:utf-8 -*- 
#       "$Name: release_01 $";
#       "$Header: /home/cvsadm/cvsroot/fermi/servers/alarmmail/AlarmMail.py,v 1.2 2016-01-14 14:41:18 graziano Exp $";

##############################################################################
## license :
##============================================================================
##
## File :        AlarmMail.py
## 
## Project :     Alarm Mail Notification
##
## This file is part of Tango device class.
## 
## Tango is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or
## (at your option) any later version.
## 
## Tango is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
## 
## You should have received a copy of the GNU General Public License
## along with Tango.  If not, see <http://www.gnu.org/licenses/>.
## 
##
## $Author :      graziano.scalamera$
##
## $Revision :    $
##
## $Date :        $
##
## $HeadUrl :     $
##============================================================================
##            This file is generated by POGO
##    (Program Obviously used to Generate tango Object)
##
##        (c) - Software Engineering Group - ESRF
##############################################################################

""""""

__all__ = ["AlarmMail", "AlarmMailClass", "main"]

__docformat__ = 'restructuredtext'

import PyTango
import sys
# Add additional import
#----- PROTECTED REGION ID(AlarmMail.additionnal_import) ENABLED START -----#
import smtplib
from email.mime.text import MIMEText

#----- PROTECTED REGION END -----#	//	AlarmMail.additionnal_import

## Device States Description
## No states for this device

class AlarmMail (PyTango.Device_4Impl):

    #--------- Add you global variables here --------------------------
    #----- PROTECTED REGION ID(AlarmMail.global_variables) ENABLED START -----#
    addressBook= {
        }
    #----- PROTECTED REGION END -----#	//	AlarmMail.global_variables

    def __init__(self,cl, name):
        PyTango.Device_4Impl.__init__(self,cl,name)
        self.debug_stream("In __init__()")
        AlarmMail.init_device(self)
        #----- PROTECTED REGION ID(AlarmMail.__init__) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	AlarmMail.__init__
        
    def delete_device(self):
        self.debug_stream("In delete_device()")
        #----- PROTECTED REGION ID(AlarmMail.delete_device) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	AlarmMail.delete_device

    def init_device(self):
        self.debug_stream("In init_device()")
        self.get_device_properties(self.get_device_class())
        #----- PROTECTED REGION ID(AlarmMail.init_device) ENABLED START -----#
        for dest in self.receivers:
                self.addressBook[dest.split('=')[0]] = dest.split('=')[1]
        #----- PROTECTED REGION END -----#	//	AlarmMail.init_device

    def always_executed_hook(self):
        self.debug_stream("In always_excuted_hook()")
        #----- PROTECTED REGION ID(AlarmMail.always_executed_hook) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	AlarmMail.always_executed_hook

    #-----------------------------------------------------------------------------
    #    AlarmMail read/write attribute methods
    #-----------------------------------------------------------------------------
    
    
    
        #----- PROTECTED REGION ID(AlarmMail.initialize_dynamic_attributes) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	AlarmMail.initialize_dynamic_attributes
            
    def read_attr_hardware(self, data):
        self.debug_stream("In read_attr_hardware()")
        #----- PROTECTED REGION ID(AlarmMail.read_attr_hardware) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	AlarmMail.read_attr_hardware


    #-----------------------------------------------------------------------------
    #    AlarmMail command methods
    #-----------------------------------------------------------------------------
    
    def SendAlarm(self, argin):
        """ 
        
        :param argin: 
        :type: PyTango.DevString
        :return: 
        :rtype: PyTango.DevVoid """
        self.debug_stream("In SendAlarm()")
        #----- PROTECTED REGION ID(AlarmMail.SendAlarm) ENABLED START -----#  
        params= {
        }
        for param in argin.split(';'):
                params[param.split('=',1)[0]] = param.split('=',1)[1]
                print('looping param=' + param)
        print(params)
        msg = MIMEText('NEW ALARM DETECTED: \nName:    ' +params['name'] + '\nMessage: ' + params['msg'] + '\nValues:  ' + params['values'] + '\nFormula: ' + params['formula'])
        msg['Subject'] = 'ALARMED ' + params['name'] + ' - ' + params['msg']
        msg['From'] = '"'+ self.email_name +'"<'+self.email_user+'>'
        groups = params['groups']
        receive = ''
        first = True
        for gr in groups.split('|'):
                print('looping gr=' + gr)
                print('  -> address=' + self.addressBook[gr])
                if first:
                        receive = receive + self.addressBook[gr]
                        first = False
                else:
                        receive = receive + ',' + self.addressBook[gr]
        #print('groups split=' + groups.split('|'))
        print('msg to=' + receive)
        msg['To'] = receive
        #msg['To'] = self.addressBook[groups] + ','
        s = smtplib.SMTP(self.email_smtp)
        s.sendmail(self.email_user,msg["To"].split(","), msg.as_string())
        s.quit()        
        #----- PROTECTED REGION END -----#	//	AlarmMail.SendAlarm
        
    def SendNormal(self, argin):
        """ 
        
        :param argin: 
        :type: PyTango.DevString
        :return: 
        :rtype: PyTango.DevVoid """
        self.debug_stream("In SendNormal()")
        #----- PROTECTED REGION ID(AlarmMail.SendNormal) ENABLED START -----#
        params= {
        }
        for param in argin.split(';'):
                params[param.split('=',1)[0]] = param.split('=',1)[1]
                print('looping param=' + param)
        print(params)
        msg = MIMEText('RESTORED TO NORMAL CONDITION: \nName:    ' +params['name'] + '\nMessage: ' + params['msg'] + '\nValues:  ' + params['values'] + '\nFormula: ' + params['formula'])
        msg['Subject'] = 'RESTORED ' + params['name'] + ' - ' + params['msg']
        msg['From'] = '"'+ self.email_name +'"<'+self.email_user+'>'
        groups = params['groups']
        receive = ''
        first = True
        for gr in groups.split('|'):
                print('looping gr=' + gr)
                print('  -> address=' + self.addressBook[gr])
                if first:
                        receive = receive + self.addressBook[gr]
                        first = False
                else:
                        receive = receive + ',' + self.addressBook[gr]
        #print('groups split=' + groups.split('|'))
        print('msg to=' + receive)
        msg['To'] = receive
        #msg['To'] = self.addressBook[groups] + ','
        s = smtplib.SMTP(self.email_smtp)
        s.sendmail(self.email_user,msg["To"].split(","), msg.as_string())
        s.quit()          
        #----- PROTECTED REGION END -----#	//	AlarmMail.SendNormal
        

    #----- PROTECTED REGION ID(AlarmMail.programmer_methods) ENABLED START -----#
    
    #----- PROTECTED REGION END -----#	//	AlarmMail.programmer_methods

class AlarmMailClass(PyTango.DeviceClass):
    #--------- Add you global class variables here --------------------------
    #----- PROTECTED REGION ID(AlarmMail.global_class_variables) ENABLED START -----#
    
    #----- PROTECTED REGION END -----#	//	AlarmMail.global_class_variables

    def dyn_attr(self, dev_list):
        """Invoked to create dynamic attributes for the given devices.
        Default implementation calls
        :meth:`AlarmMail.initialize_dynamic_attributes` for each device
    
        :param dev_list: list of devices
        :type dev_list: :class:`PyTango.DeviceImpl`"""
    
        for dev in dev_list:
            try:
                dev.initialize_dynamic_attributes()
            except:
                import traceback
                dev.warn_stream("Failed to initialize dynamic attributes")
                dev.debug_stream("Details: " + traceback.format_exc())
        #----- PROTECTED REGION ID(AlarmMail.dyn_attr) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	AlarmMail.dyn_attr

    #    Class Properties
    class_property_list = {
        }


    #    Device Properties
    device_property_list = {
        'receivers':
            [PyTango.DevVarStringArray,
            "groupname=email",
            [] ],
        'email_name':
            [PyTango.DevString,
            "email name",
            ["Control Alarms"] ],
        'email_smtp':
            [PyTango.DevString,
            "SMTP server",
            ["smtp"] ],
        'email_user':
            [PyTango.DevString,
            "email user",
            [] ],
        }


    #    Command definitions
    cmd_list = {
        'SendAlarm':
            [[PyTango.DevString, "none"],
            [PyTango.DevVoid, "none"]],
        'SendNormal':
            [[PyTango.DevString, "none"],
            [PyTango.DevVoid, "none"]],
        }


    #    Attribute definitions
    attr_list = {
        }


def main():
    try:
        py = PyTango.Util(sys.argv)
        py.add_class(AlarmMailClass,AlarmMail,'AlarmMail')
        #----- PROTECTED REGION ID(AlarmMail.add_classes) ENABLED START -----#
        
        #----- PROTECTED REGION END -----#	//	AlarmMail.add_classes

        U = PyTango.Util.instance()
        U.server_init()
        U.server_run()

    except PyTango.DevFailed,e:
        print '-------> Received a DevFailed exception:',e
    except Exception,e:
        print '-------> An unforeseen exception occured....',e

if __name__ == '__main__':
    main()
